if(typeof($add)=="undefined")var $add={version:{},auto:{disabled:false}};(function($){
  $add.version.Select = "2.0.2";
  $add.Select = function(selector, settings){
    var objs = $(selector).map(function(i, el){
      var $el = $(el);
      var S = {};
      if($el.attr("multiple")){
        S = {
          max: 99999999,
          closeOnSelect: false
        };
      }
      if($el.attr("required"))
        S.min = 1;
      if($el.attr("placeholder"))
        S.placeholder = $el.attr("placeholder");
      if($el.attr("id"))
        S.id = $el.attr("id");
      if($el.attr("class"))
        S.class = $el.attr("class");
      if($el.attr("name"))
        S.name = $el.attr("name");
      S = $.extend(S, $el.data(), settings);

      var options = $el.find("option").map(function(i, op){
        var $op = $(op);
        return {
          label: $op.html(),
          value: $op.val()
        };
      }).toArray();

      var obj = new $add.Select.obj(options, S);
      obj.render($el, "replace");
      return obj;
    });
    return (objs.length==0)?null:(objs.length==1)?objs[0]:objs;
  };
  $add.Select.obj = Obj.create(function(options, settings){
    this.defSettings({
      max: 1,
      min: 0,
      id: "",
      name: "",
      class: "",
      placeholder: "Choose an Option",
      closeOnSelect: true
    });
    this.defMember("options", [], function(newOptions){
      this.addOption(newOptions);
    });
    this.defMethod("addOption", function(newOption){
      if(newOption instanceof Array){
        for(var i=0; i<newOption.length; i++){
          this.addOption(newOption[i]);
        }
        return;
      }
      if(typeof(newOption) != "object"){
        var o = {
          label: newOption,
          value: newOption,
          selected: false
        };
        newOption = o;
      }
      this._options.push(newOption);
      this.trigger("options", this._options);
    });
    this.defMethod("removeOption", function(option){
      for(var i=0; i<this._options.length; i++){
        if(
          (
            typeof(option) == "object" &&
            option.value == this._options.value
          ) ||
          option == this._options.value
        ){
          this._options.splice(i--, 1);
        }
      }
    });
    this.defMethod("select", function(option){
      if(typeof(option)=="object" && options.value!==undefined)option = option.value;
      for(var i=0; i<this._options.length; i++){
        if(this._options[i].value == option){
          this._options[i].selected = true;
        }
      }
      this.refresh("select");
    });
    this.defMethod("deselect", function(option){
      if(typeof(option)=="object" && options.value!==undefined)option = option.value;
      for(var i=0; i<this._options.length; i++){
        if(this._options[i].value == option){
          this._options[i].selected = false;
        }
      }
      this.refresh("select");
    });
    this.defMethod("_deselectLast", function(){
      for(var i=this._options.length-1; i>-1; i--){
        if(this._options[i].selected){
          this._options[i].selected = false;
          return;
        }
      }
    });
    this.defMethod("selectToggle", function(option){
      if(typeof(option)=="object" && options.value!==undefined)option = option.value;
      for(var i=0; i<this._options.length; i++){
        if(this._options[i].value == option){
          var selected = !this._options[i].selected;
          if(selected){
            if(this._settings.max <= this.selectedCount()){
              this._deselectLast();
            }
            this._options[i].selected = true;
          } else {
            if(this._settings.min < this.selectedCount()){
              this._options[i].selected = false;
            }
          }
        }
      }
      this.refresh("select");
    });
    this.defMethod("getValue", function(){
      var values = [];
      for(var i=0; i<this._options.length; i++){
        if(this._options[i].selected){
          values.push(this._options[i].value);
        }
      }
      return values.join(", ");
    });
    this.defMethod("selectedCount", function(){
      var count = 0;
      for(var i=0; i<this._options.length; i++){
        if(this._options[i].selected){
          count++;
        }
      }
      return count;
    });
    this.renderer = function(){
      var self = this;
      var $select = $("<div class='addui-select "+this._settings.class+"'></div>");

      var value = this._getValue.call(this);

      var $value = $("<div class='addui-select-value "+((value)?"":"addui-select-placeholder")+"'>"+(value || this._settings.placeholder)+"</div>").appendTo($select);

      var $input = $("<input type='hidden' class='addui-select-input' id='"+this._settings.id+"' name='"+this._settings.name+"' />").appendTo($select);

      var $options = $("<div class='addui-select-options'></div>").appendTo($select);
      for(var i=0; i<this._options.length; i++){
        (function(){
          var o = self._options[i];
          var $option = $("<div class='addui-select-option "+((o.selected)?"addui-select-option-selected":"")+"' data-value='"+o.value+"'>"+o.label+"</div>").on("click", function(){
            self.selectToggle(o.value);
          }).appendTo($options);
        })();
      }

      $value.on("click", function(){
        var openBefore = $select.hasClass("addui-select-open");
        $select.toggleClass("addui-select-open");
        if(!openBefore && self._settings.closeOnSelect){
          setTimeout(function(){
            $(window).one("click", function(){
              $select.removeClass("addui-select-open");
            });
          }, 301);
        }
      });

      return $select;
    };
    this.refresher = function($select, changed){
      if(changed  == "select"){
        $select.find(".addui-select-option-selected").removeClass("addui-select-option-selected");
        for(var i=0; i<this._options.length; i++){
          if(this._options[i].selected){
            $select.find("[data-value=\""+this._options[i].value+"\"]").addClass("addui-select-option-selected");
          }
        }
        var $value = $select.find(".addui-select-value");
        var value = this.getValue();
        if(!value){
          $value.addClass("addui-select-placeholder");
          $value.html(this._settings.placeholder);
        } else {
          $value.removeClass("addui-select-placeholder");
          $value.html(value);
        }
        $select.find(".addui-select-input").val(value);
      } else return this.renderer.call(this);
    };
    this.init = function(options, settings){
      if(options)
        this.options = options;
      if(settings)
        this.settings = settings;
    };
    this.init.apply(this, arguments);
  });
  $.fn.addSelect = function(settings){
    $add.Select(this, settings);
  };
  $add.auto.Select = function(){
    if(!$add.auto.disabled){
      $("[data-addui=select]").addSelect();
    }
  }
})(jQuery);
$(function(){for(var k in $add.auto){if(typeof($add.auto[k])=="function"){$add.auto[k]();}}});